'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createClient = undefined;

require('babel-polyfill');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//  This ensures any serverProps are passed to React
//  on the first initial load
var getClientProps = function getClientProps() {
  try {
    var scriptsEl = document.getElementById('app-props');
    var props = scriptsEl ? scriptsEl.textContent : {};

    //  eslint-disable-next-line
    props = props.replace("<![CDATA[", "").replace("]]>", "");
    return JSON.parse(props);
  } catch (err) {
    throw new Error('Error parsing client props');
  }
};

//  This code block creates a hot-module-reloading
//  subscription for the extracted CSS bundle
//  Since we can't have a FOUC during initial page render, when
//  the extracted CSS bundle is updated, we receive an event and new styles
//  are injected into the <head />

if (module && module.hot) {
  var head = document.head || document.getElementsByTagName('head')[0];
  var hotInlineStyles = document.createElement('style');
  hotInlineStyles.type = 'text/css';
  head.appendChild(hotInlineStyles);

  require('webpack-hot-middleware/client').subscribe(function (updateEvent) {
    if (updateEvent.type === 'css-update') {
      hotInlineStyles.textContent = '';
      hotInlineStyles.appendChild(document.createTextNode(updateEvent.value));
    }
  });
}

var createClient = exports.createClient = function createClient(config) {
  var serverProps = getClientProps();

  var Root = config.root;

  return _react2.default.createElement(
    _reactRouterDom.BrowserRouter,
    null,
    _react2.default.createElement(Root, serverProps)
  );
};

exports.default = createClient;